//Minified w/ JSMin: see https://github.com/1ec5/avim/blob/v5.4.0/components/transformer.js
"use strict";const Cc=Components.classes,Ci=Components.interfaces,Cu=Components.utils;
const CLASS_ID=Components.ID("{4A373444-8A2A-4641-ADD5-897A88D05185}"),CLASS_NAME="AVIM text transformer service",CONTRACT_ID="@1ec5.org/avim/transformer;1";let Transformation=(function(){const fcc=String.fromCharCode,up=String.toUpperCase;function nan(w){return isNaN(w)||w=='e';}
function codesFromChars(chars){let codes=[];for(let i=0;i<chars.length;i++){codes.push(chars[i].charCodeAt(0));}
return codes;}
function lowerUpper(chars){return chars.toLowerCase()+chars.toUpperCase();}
function upperLower(chars){return chars.toUpperCase()+chars.toLowerCase();}
function intersperseLowerUpper(chars){let arr=[];for(let i=0;i<chars.length;i++){arr.push(chars[i].toLowerCase(),chars[i].toUpperCase());}
return arr;}
const alphabet="QWERTYUIOPASDFGHJKLZXCVBNM ",skey_str=lowerUpper("a\u00e2\u0103e\u00eaio\u00f4\u01a1u\u01b0y").split(""), skey2=lowerUpper("aaaeeiooouuy").split(""),skey=codesFromChars(skey_str),db1=[0x0111 ,0x0110 ],ds1=['d','D'],os1=intersperseLowerUpper("o\u01a1\u00f3\u00f2\u1ecd\u1ecf\u00f5\u1edb\u1edd\u1ee3\u1edf\u1ee1"), ob1=intersperseLowerUpper("\u00f4\u00f4\u1ed1\u1ed3\u1ed9\u1ed5\u1ed7\u1ed1\u1ed3\u1ed9\u1ed5\u1ed7"), mocs1=intersperseLowerUpper("o\u00f4u\u00f3\u00f2\u1ecd\u1ecf\u00f5\u00fa\u00f9\u1ee5\u1ee7\u0169\u1ed1\u1ed3\u1ed9\u1ed5\u1ed7"), mocb1=intersperseLowerUpper("\u01a1\u01a1\u01b0\u1edb\u1edd\u1ee3\u1edf\u1ee1\u1ee9\u1eeb\u1ef1\u1eed\u1eef\u1edb\u1edd\u1ee3\u1edf\u1ee1"), trangs1=intersperseLowerUpper("a\u00e2\u00e1\u00e0\u1ea1\u1ea3\u00e3\u1ea5\u1ea7\u1ead\u1ea9\u1eab"), trangb1=intersperseLowerUpper("\u0103\u0103\u1eaf\u1eb1\u1eb7\u1eb3\u1eb5\u1eaf\u1eb1\u1eb7\u1eb3\u1eb5"), as1=intersperseLowerUpper("a\u0103\u00e1\u00e0\u1ea1\u1ea3\u00e3\u1eaf\u1eb1\u1eb7\u1eb3\u1eb5"), ab1=intersperseLowerUpper("\u00e2\u00e2\u1ea5\u1ea7\u1ead\u1ea9\u1eab\u1ea5\u1ea7\u1ead\u1ea9\u1eab"), es1=intersperseLowerUpper("e\u00e9\u00e8\u1eb9\u1ebb\u1ebd"), eb1=intersperseLowerUpper("\u00ea\u1ebf\u1ec1\u1ec7\u1ec3\u1ec5"), english="\u0110\u00c2\u0102\u01a0\u01af\u00ca\u00d4", lowen=english.toLowerCase(),arA=lowerUpper("\u00e1\u00e0\u1ea3\u00e3\u1ea1a").split(""), mocrA=lowerUpper("\u00f3\u00f2\u1ecf\u00f5\u1ecdo\u00fa\u00f9\u1ee7\u0169\u1ee5u").split(""), erA=lowerUpper("\u00e9\u00e8\u1ebb\u1ebd\u1eb9e").split(""), orA=lowerUpper("\u00f3\u00f2\u1ecf\u00f5\u1ecdo").split(""), aA=lowerUpper("\u1ea5\u1ea7\u1ea9\u1eab\u1ead\u00e2").split(""), oA=lowerUpper("\u1ed1\u1ed3\u1ed5\u1ed7\u1ed9\u00f4").split(""), mocA=lowerUpper("\u1edb\u1edd\u1edf\u1ee1\u1ee3\u01a1\u1ee9\u1eeb\u1eed\u1eef\u1ef1\u01b0").split(""), trangA=lowerUpper("\u1eaf\u1eb1\u1eb3\u1eb5\u1eb7\u0103").split(""), eA=lowerUpper("\u1ebf\u1ec1\u1ec3\u1ec5\u1ec7\u00ea").split("");const DAWEOFA=up(aA.join()+eA.join()+mocA.join()+trangA.join()+
oA.join()+english);const bya=[db1,ab1,eb1,ob1,mocb1,trangb1],sfa=[ds1,as1,es1,os1,mocs1,trangs1];const ccA=[aA,mocA,trangA,eA,oA],ccrA=[arA,mocrA,arA,erA,orA];const methods={telex:{DAWEO:"DAWEO",SFJRX:"SFJRX",FRX:"FRX",S:"S",F:"F",J:"J",R:"R",X:"X",Z:"Z",D:"D",them:"AOEW",moc:"W",trang:"W",A:"A",E:"E",O:"O"},vni:{DAWEO:"6789",SFJRX:"12534",FRX:"234",S:"1",F:"2",J:"5",R:"3",X:"4",Z:"0",D:"9",them:"678",moc:"7",trang:"8",AEO:"6",A:"6",E:"6",O:"6"},viqr:{DAWEO:"^+(D",SFJRX:"'`.?~",FRX:"`?~",S:"'",F:"`",J:".",R:"?",X:"~",Z:"-",D:"D",them:"^+(",moc:"+",trang:"(",AEO:"^",A:"^",E:"^",O:"^"},viqrStar:{DAWEO:"^*(D",SFJRX:"'`.?~",FRX:"`?~",S:"'",F:"`",J:".",R:"?",X:"~",Z:"-",D:"D",them:"^*(",moc:"*",trang:"(",AEO:"^",A:"^",E:"^",O:"^"},};function unV2(w){let unW="";for(let a=w.length-1;a>=0;a--){let pos=skey.indexOf(w.charCodeAt(a));if(pos>=0)unW=skey2[pos]+unW;else unW=w[a]+unW;}
return unW;};function Transformation(startValue,context){this.value=startValue;this.startLength=this.value.length;this.context={method:context.method,autoMethods:{telex:context.autoMethods.telex,vni:context.autoMethods.vni,viqr:context.autoMethods.viqr,viqrStar:context.autoMethods.viqrStar,},ckSpell:context.ckSpell,informal:context.informal,oldAccent:context.oldAccent,keyCode:context.keyCode,which:context.which,shiftKey:context.shiftKey,};}
Transformation.prototype={changed:false,whit:false,tw5:false,methodIsVIQR:function(){if(this.context.method>2)return true;return this.context.method==0&&(this.context.autoMethods.viqr||this.context.autoMethods.viqrStar);},splice:function(index,len,repl){let val=this.value;this.value=val.substr(0,index)+repl+val.substr(index+len);return repl.length-len;},ckspell:function(w,k){if(!this.context.ckSpell)return false;let uk=up(k); let num=/^([0-9]+)(d?)$/.exec(w);let isVni=this.context.method==2||(this.context.method==0&&this.context.autoMethods.vni);if(num){ if(!num[2]&&uk=="D")return false; if(num[2]&&uk==this.method.D)return false;}
w=this.unV(w);let uw=up(w),tw=uw,uw2=unV2(uw),twE;let vSConsonant="BCD\u0110GHKLMNPQRSTVX";let vDConsonant="[CKNP]H|G[HI]|NGH?|QU|T[HR]";if(this.context.informal){vSConsonant+="F";vDConsonant+="|DZ";} 
if(uw=="NG"&&uk==this.method.X&&this.context.informal){return false;} 
let nonViet="A-EGHIK-VXY\u0110";if(this.context.informal)nonViet+="FZ";if(new RegExp("[^"+nonViet+"]").test(uw2))return true; if(this.method.FRX.indexOf(uk)>=0&&/[CPT]$|CH$/.test(uw)){return true;} 
if(this.context.informal){if(/^Z|[^D]Z/.test(uw))return true;}
else if(uw.indexOf("F")>=0||uw.indexOf("Z")>=0)return true;
 if(/^(?:C[IEY]|CUY|CO[AE]|G[EY]|NG[IEY]|NGH[AOUY]|Q[^U]|QU[^AEIOY])/.test(uw2)){ return true;}
if(uw2=="QU"&&(this.method.DAWEO||this.method.SFJRX)){return true;} 
let vowRe=/A[AE]|E[AEIY]|EU[AEIOUY]|I[IY]|^IO|[^G]IO|OOO|^OU|[^U]OU|UU.|Y[AIOY]/;if(vowRe.test(uw2))return true; let consRe=vDConsonant+"|["+vSConsonant+"]";let cons=new RegExp("^(?:"+consRe+")").exec(tw);if(cons&&cons[0])tw=tw.substr(cons[0].length);twE=tw; let endCons=/(?:[MPT]|CH?|N[GH]?)$/.exec(tw);if(endCons&&endCons[0]){tw=tw.substr(0,tw.length-endCons[0].length); if(endCons[0]=="NH"){if(/^(?:[\u0102\u00c2\u00d4\u01a0]|I[E\u00ca]|O[\u0102E\u00ca]?|[U\u01af][AO\u01a0]?|UY[E\u00ca])$/.test(tw)){return true;}
if(uk==this.method.trang&&(tw=="A"||tw=="OA")){return true;}}
if(!tw&&cons&&cons[0]!="GI")return true;} 
if(tw&&new RegExp(consRe).test(tw))return true;uw2=unV2(tw);if(uw2=="IAO")return true; if(tw!=twE&&/A[IOUY]|IA|IEU|UU|UO[UI]/.test(uw2))return true;if(tw!=uw&&uw2=="YEU")return true;if(uk==this.method.AEO&&/\u01af[AEO\u01a0]$/.test(tw))return true;if(this.method.them.indexOf(uk)>=0&&!/^.UYE/.test(uw2)&&uk!="E"){if(/A[IO]|EO|IA|O[EO]/.test(uw2))return true;if(uk==this.method.trang){if(this.method.trang!="W"&&uw2=="UA")return true;}
else if(uw2=="OA")return true;if(uk==this.method.moc&&/^(?:[EI]U|UE|UYE?)$/.test(uw2)){return true;}
if(uk==this.method.moc||uk==this.method.trang){if(uw2=="AU"||uw2=="AY")return true;}}
this.tw5=tw; return uw2.length>3;},mozGetText:function(){let pos=this.startLength;if(pos<0)return false;let w=this.value.substring(0,pos);if(w.substr(-1)=="\\"&&this.methodIsVIQR())return["\\",pos];return[w,pos];},start:function(){let method=this.context.method,dockspell=this.context.ckSpell;let uniA=[];this.D2="";if(method==1||(method==0&&this.context.autoMethods.telex)){uniA.push("DAEOWW".split(""));this.D2+="DAWEO";}
if(method==2||(method==0&&this.context.autoMethods.vni)){uniA.push("966678".split(""));this.D2+="6789";}
if(method==3||(method==0&&this.context.autoMethods.viqr)){uniA.push("D^^^+(".split(""));this.D2+="D^+(";}
if(method==4||(method==0&&this.context.autoMethods.viqrStar)){uniA.push("D^^^*(".split(""));this.D2+="D^*(";}
let w=this.mozGetText();if(!w)return; let key="";const backspace=Ci.nsIDOMKeyEvent.DOM_VK_BACK_SPACE;if(!this.context.keyCode||this.context.keyCode!=backspace||!this.context.shiftKey){key=fcc(this.context.which);}
let noNormC=this.D2.indexOf(up(key))>=0;for(let i=0;i<uniA.length;i++){if(!dockspell)w=this.mozGetText();if(!w||this.changed)break;this.main(w[0],key,w[1],uniA[i],noNormC);w=this.mozGetText();if(w)this.convertCustomChars(w[0],key,w[1]);}
if(this.D2.indexOf(up(key))>=0){w=this.mozGetText();if(w)this.normC(w[0],key,w[1]);}},convertCustomChars:function(word,key,pos){let uw=up(word),uk=up(key);if(/^[0-9]+.$/.test(word)||word=="\u20ab"){ let lastChar=word.substr(-1);if(lastChar=="\u0111"&&uk==this.method.D){this.splice(pos-1,1,"\u20ab"); this.changed=true;}
else if(lastChar=="\u20ab"&&uk==this.method.D){this.splice(pos-1,1,"d"+key);this.changed=true;}
else if(lastChar=="\u20ab"&&uk==this.method.Z){this.splice(pos-1,1,"d");this.changed=true;}
return;}
if(this.context.informal||!this.context.ckSpell){if(uw=="NG"&&uk==this.method.X){this.splice(pos,0,"\u0303");this.changed=true;}
else if(uw=="NG\u0303"&&uk==this.method.X){this.splice(pos-1,1,key);this.changed=true;}
else if(uw=="NG\u0303"&&uk==this.method.Z){this.splice(pos-1,1,"");this.changed=true;}}},findC:function(w,k,sf){let method=this.context.method;if(this.methodIsVIQR()&&w.substr(-1)=="\\"){return[1,k.charCodeAt(0)];}
let str="",res,cc="",pc="",vowA=[],s=upperLower("\u00c2\u0102\u00ca\u00d4\u01a0\u01af"),c=0,dn=false,uw=up(w),tv,g; let h,uc;for(let g=0;g<sf.length;g++){str+=nan(sf[g])?sf[g]:fcc(sf[g]);}
let uk=up(k),w2=up(unV2(this.unV(w))),dont=["\u01afA","\u01afU"];if(this.method.DAWEO.indexOf(uk)>=0){ if(uk==this.method.moc){if(w2.indexOf("UU")>=0&&this.tw5!=dont[1]){if(w2.substr(-2)!="UU")return false;res=2;}
else if(w2.indexOf("UOU")>=0){if(w2.substr(-3)!="UOU")return false;res=2;}}
if(!res){for(let g=1;g<=w.length;g++){cc=w.substr(-g,1);pc=up(w.substr(-g-1,1));uc=up(cc);if(this.tw5==this.unV(pc+uc)&&dont.indexOf(this.tw5)>=0){continue;}
if(str.indexOf(uc)>=0){if((uk==this.method.moc&&this.unV(uc)=="U"&&up(this.unV(w.substr(-g+1,1)))=="A")||(uk==this.method.trang&&this.unV(uc)=="A"&&this.unV(pc)=="U")){tv=1+(this.unV(uc)!="U");let ccc=up(w.substr(-g-tv,1));if(ccc!="Q"){res=g+tv-1;}else if(uk==this.method.trang){res=g;}else if(this.method.moc!=this.method.trang){return false;}}else{res=g;}
if(!this.whit||(uw.indexOf("\u01af")<0)||(uw.indexOf("W")<0)){break;}}else if(DAWEOFA.indexOf(uc)>=0){if(uk==this.method.D){if(cc=="\u0111"){ res=[g,'d'];}else if(cc=="\u0110"){ res=[g,'D'];}}else{res=this.DAWEOF(cc,uk,g);}
if(res)break;}}}}
let tE="",tEC;if(uk!=this.method.Z&&this.method.DAWEO.indexOf(uk)<0){tE=this.retKC(uk,true);}
if(this.method.DAWEO.indexOf(uk)<0)for(let g=1;g<=w.length;g++){cc=up(w.substr(-g,1));pc=up(w.substr(-g-1,1));if(str.indexOf(cc)>=0){if(cc=='U'){if(pc!='Q'){c++;vowA.push(g);}}else if(cc=='I'){if((pc!='G')||(c<=0)){c++;vowA.push(g);}}else{c++;vowA.push(g);}}
else if(uk!=this.method.Z){let h=this.repSign(k).indexOf(w.charCodeAt(w.length-g));if(h>=0){if(this.ckspell(w,k))return false;return[g,tE.charCodeAt(h%24)];}
for(let h=0;h<tE.length;h++){if(tE.charCodeAt(h)==w.charCodeAt(w.length-g)){return[g,skey_str[h]];}}}}
if(uk!=this.method.Z&&typeof(res)!='object'&&this.ckspell(w,k)){return false;}
if(this.method.DAWEO.indexOf(uk)<0){for(let g=1;g<=w.length;g++){if(uk!=this.method.Z&&s.indexOf(w.substr(-g,1))>=0){return g;}
if(tE.indexOf(w.substr(-g,1))>=0){let pos=tE.indexOf(w.substr(-g,1));if(pos>=0)return[g,skey_str[pos]];}}}
if(res)return res;if(c==1||uk==this.method.Z)return vowA.length&&vowA[0];else if(c==2){let upW=up(w);if(!this.context.oldAccent&&/(?:UY|O[AE]) ?$/.test(upW)){return vowA[0];}
let cons=upW.match(/[BCDĐGHKLMNPQRSTVX]+$/);if(cons){cons=cons[0].match(/NGH?|[CGKNPT]H|GI|QU|TR|[BCDĐGHKLMNPQRSTVX]/g);if(cons&&cons.length<3)return vowA[0];}
return vowA[1];}
else if(c==3)return vowA[1];return false;},replaceChar:function(pos,c){let val=this.value; let bb=false;let replaceBy;let wfix;if(!nan(c)){replaceBy=fcc(c),wfix=up(this.unV(fcc(c)));this.changed=true;}else{replaceBy=c;if((up(c)=="O")&&this.whit){bb=true;}}
let r;if(up(val.substr(pos-1,1))=='U'&&pos<this.startLength-1&&up(val.substr(pos-2,1))!='Q'){if(wfix=="\u01a0"||bb){r=(val.substr(pos-1,1)=='u')?"\u01b0":"\u01af";}
if(bb){this.changed=true;replaceBy=(c=="o")?"\u01a1":"\u01a0";}}
if(r){replaceBy=r+replaceBy;pos--;}
this.splice(pos,1+!!r,replaceBy);this.whit=false;},tr:function(k,w,by,sf,i){let pos=this.findC(w,k,sf);if(!pos)return false;if(pos[1])return this.replaceChar(i-pos[0],pos[1]);let pC=w.substr(-pos,1);for(let g=0;g<sf.length;g++){let cmp=nan(sf[g])?pC:pC.charCodeAt(0);if(cmp==sf[g]){let c=nan(by[g])?by[g].charCodeAt(0):by[g];return this.replaceChar(i-pos,c);}}
return false;},main:function(w,k,i,a,noNormC){let uk=up(k),got=false,t=intersperseLowerUpper("daaoueo");let by=[],sf=[],method=this.context.method,h,g;if(method==0){if(a[0]=="9")method=2;else if(a.length>3&&a[4]=="+")method=3;else if(a.length>3&&a[4]=="*")method=4;else if(a[0]=="D")method=1;}
this.method=[null,methods.telex,methods.vni,methods.viqr,methods.viqrStar,][method]; if(k==""){k=this.method.Z;uk=up(k);}
if(this.method.SFJRX.indexOf(uk)>=0){this.sr(w,k,i);got=true;}
else if(uk==this.method.Z){sf=this.repSign(null);for(h=0;h<english.length;h++){sf.push(lowen.charCodeAt(h),english.charCodeAt(h));}
by=skey.concat(skey,skey,skey,skey,t);got=true;}
else for(h=0;h<a.length;h++){if(a[h]==uk){got=true;by=by.concat(bya[h]);sf=sf.concat(sfa[h]);}}
if(uk==this.method.moc)this.whit=true;if(got)return this.DAWEOZ(k,w,by,sf,i,uk);if(noNormC)return"";return this.normC(w,k,i);},DAWEOZ:function(k,w,by,sf,i,uk){if(this.method.DAWEO.indexOf(uk)<0&&this.method.Z.indexOf(uk)<0){return false;}
return this.tr(k,w,by,sf,i);},normC:function(w,k,i){if(k=="")k=this.method.Z;if(k[0]==" ")return"";let uk=up(k);if(alphabet.indexOf(uk)<0&&this.D2.indexOf(uk)<0)return w;let u=this.repSign(null);for(let j=1;j<=w.length;j++){let h=u.indexOf(w.charCodeAt(w.length-j));if(h<0)continue;let fS=this.method.X;if(h<=23)fS=this.method.S;else if(h<=47)fS=this.method.F;else if(h<=71)fS=this.method.J;else if(h<=95)fS=this.method.R;let c=skey[h%24];let sp=this.startLength;let end=this.startLength;let pos=sp;w=this.unV(w);if(!this.changed){w+=k;pos+=k.length;this.splice(sp,end-sp,k);this.changed=true;}
if(!this.ckspell(w,fS)){this.replaceChar(i-j,c);this.main(w,fS,pos,[this.method.D],false);}}
return"";},DAWEOF:function(cc,k,g){let kA=[this.method.A,this.method.moc,this.method.trang,this.method.E,this.method.O];for(let i=0;i<kA.length;i++){if(k!=kA[i])continue;let posCC=ccA[i].indexOf(cc);if(posCC<0)continue;let repl=ccrA[i][posCC];return repl?[g,repl]:false;}
return false;},retKC:function(k,giveChars){let chars="";switch(k){case this.method.S:chars=lowerUpper("\u00e1\u1ea5\u1eaf\u00e9\u1ebf\u00ed\u00f3\u1ed1\u1edb\u00fa\u1ee9\u00fd");break; case this.method.F:chars=lowerUpper("\u00e0\u1ea7\u1eb1\u00e8\u1ec1\u00ec\u00f2\u1ed3\u1edd\u00f9\u1eeb\u1ef3");break; case this.method.J:chars=lowerUpper("\u1ea1\u1ead\u1eb7\u1eb9\u1ec7\u1ecb\u1ecd\u1ed9\u1ee3\u1ee5\u1ef1\u1ef5");break; case this.method.R:chars=lowerUpper("\u1ea3\u1ea9\u1eb3\u1ebb\u1ec3\u1ec9\u1ecf\u1ed5\u1edf\u1ee7\u1eed\u1ef7");break; case this.method.X:chars=lowerUpper("\u00e3\u1eab\u1eb5\u1ebd\u1ec5\u0129\u00f5\u1ed7\u1ee1\u0169\u1eef\u1ef9");}
return giveChars?chars:codesFromChars(chars);},unV:function(w){let u=this.repSign(null);let unW="";for(let a=w.length-1;a>=0;a--){let pos=u.indexOf(w.charCodeAt(a));if(pos>=0)unW=skey_str[pos%24]+unW;else unW=w[a]+unW;}
return unW;},repSign:function(k){let u=[];for(let a=0;a<5;a++){if(!k||this.method.SFJRX[a]!=up(k)){u=u.concat(this.retKC(this.method.SFJRX[a]));}}
return u;},sr:function(w,k,i){let pos=this.findC(w,k,skey_str);if(!pos)return;if(pos[1])this.replaceChar(i-pos[0],pos[1]);else this.replaceChar(i-pos,this.retUni(w,k,pos));},retUni:function(w,k,pos){let uC,lC;let idx=skey_str.indexOf(w.substr(-pos,1));if(idx<0)return false;if(idx<12){lC=idx;uC=idx+12;}
else{lC=idx-12;uC=idx;}
let t=w.substr(-pos,1);let u=this.retKC(up(k));if(t!=up(t))return u[lC];return u[uC];},};return Transformation;})();function AVIMTransformerService(){this.wrappedJSObject=this;}
AVIMTransformerService.prototype={QueryInterface:function(iid){if(iid.equals(Ci.nsISupports))return this;throw Components.results.NS_ERROR_NO_INTERFACE;},applyKey:function(prefix,context){let result={oldValue:prefix,};if(!prefix)return result;let xform=new Transformation(prefix,context);try{xform.start();result.value=xform.value;result.changed=xform.changed;}
catch(exc){}
finally{xform=null;return result;}},}
let AVIMTransformerServiceFactory={singleton:null,createInstance:function(outer,iid){if(outer)throw Components.results.NS_ERROR_NO_AGGREGATION;if(!this.singleton)this.singleton=new AVIMTransformerService();return this.singleton.QueryInterface(iid);},};var AVIMTransformerServiceModule={registerSelf:function(compMgr,fileSpec,location,type){compMgr=compMgr.QueryInterface(Ci.nsIComponentRegistrar);compMgr.registerFactoryLocation(CLASS_ID,CLASS_NAME,CONTRACT_ID,fileSpec,location,type);},unregisterSelf:function(compMgr,location,type){compMgr=compMgr.QueryInterface(Ci.nsIComponentRegistrar);compMgr.unregisterFactoryLocation(CLASS_ID,location);},getClassObject:function(compMgr,cid,iid){if(!iid.equals(Components.interfaces.nsIFactory)){throw Components.results.NS_ERROR_NOT_IMPLEMENTED;}
if(cid.equals(CLASS_ID))return AVIMTransformerServiceFactory;throw Components.results.NS_ERROR_NO_INTERFACE;},canUnload:function(compMgr){return true;},};function NSGetModule(compMgr,fileSpec){return AVIMTransformerServiceModule;}
function NSGetFactory(cid){let cidStr=cid.toString();if(cidStr==CLASS_ID)return AVIMTransformerServiceFactory;throw Components.results.NS_ERROR_FACTORY_NOT_REGISTERED;};